#include "STM32.h"
#include "SButton.h"
#include "IO_Digital.h"

// На моей плате светодиоды здесь. Правьте в соответствии со схемой своей плыты
#define LED1_GPIO  GPIOA
#define LED1_PIN   GPIO_PIN_6
#define LED2_GPIO  GPIOA
#define LED2_PIN   GPIO_PIN_7

// А кнопки здесь
#define KEY1_GPIO  GPIOE
#define KEY1_PIN   GPIO_PIN_3
#define KEY2_GPIO  GPIOE
#define KEY2_PIN   GPIO_PIN_4

IO_Digital  Led1(LED1_GPIO, LED1_PIN, Output, No_Pull);
IO_Digital  Led2(LED2_GPIO, LED2_PIN, Output, No_Pull);

SButton     Butt01(GPIOA, GPIO_PIN_0, NORM_OPEN, HIGH_PULL);          // Кнопка подключена к GND, пин подтянут к VCC
SButton     Butt02(GPIOA, GPIO_PIN_0, NORM_OPEN, HIGH_PULL);          // в ооих случаях

int main(void)
{
  while (1)
  {
    if(Butt01.isClick()) Led1.digitalTogglePin();                     // По клику первой кнопки изменяем состояние первого светодиода
    if(Butt02.isDouble()) Led2.digitalTogglePin();                    // По двойному клику второй кнопки изменяем состояние второго светодиода
  }
}

void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
//  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

