#include "STM32.h"
#include "IO_Digital.h"
#include "UART.h"


IO_Digital  Led01(GPIOC, GPIO_PIN_6, Output, No_Pull);      // Инициализируем вывод C6
IO_Digital  Led08(GPIOC, GPIO_PIN_13, High);                // Инициализируем вывод C13 на выход с "1" на выходе
IO_Digital Parallel(GPIOC, GPIO_PIN_8, 4, Output, No_Pull); // Инициализируем 4 вывода с C8 по C11 на выход
uart  myUART(USART1);                                       // Инициализируем USART1



int main(void)
{
  SystemClock_Config(Quartz_8);                             // Инициализируем тактовый генератор
  myUART.init(256000);                                      // Говорим UART с какой скоростью работать

  while(1)
  {
    Parallel.digitalWriteByte(0x03);                        // Выводим 0х03 на параллельный выход
    // В данном случае выводится то, что мы записали в порт. Так как мы не переинициализировали на вход
    myUART.println(Parallel.digitalReadByte(), HEX);        // Выводим в UART считанные данные с порта
    delay(500);                                             // Задержка
    Parallel.digitalWriteByte(0x0C);                        // Выводим 0х0С на параллельный выход
    // В данном случае выводится то, что мы записали в порт. Так как мы не переинициализировали на вход
    myUART.println(Parallel.digitalReadByte(), HEX);        // Выводим в UART считанные данные с порта
    delay(500);                                             // Задержка
    Parallel.setInput();
    // В данном случае выводится 0x00. Так как на вход мы ничего не подали
    myUART.println(Parallel.digitalReadByte(), HEX);        // Выводим в UART считанные данные с порта
    Parallel.setOutput();
    Led01.digitalTogglePin();                               // Изменяем состояние 2х пинов для того,
    Led08.digitalTogglePin();                               // что бы убедится, что мы ничего не испортили
  }
}

void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
//  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

