#include "STM32.h"
#include "UART.h"

uart  myUART(USART1, false);                      // Создаём класс myUSART

int main(void)
{
  // Инициализируем разные переменные, с которыми будем баловаться.
  int16_t   Get;
  char Str[] = "String 1, Строка 1";
  char Sim = 'A';
  uint16_t Alpha = 65534;
  uint8_t Array[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};

  SystemClock_Config(Quartz_8);                   // Инициализируем тактовый генератор
  myUART.init(256000);                            // Инициализируем UART на скорость 256 000

//  myUART.SetBuffSize(512);                                                                    // Если раскомментировать, буфер приёма/передачи увеличится до 512 байт

  // Передача данных в разных форматах
  myUART.print("Массив char     : "); myUART.println(Str);                                    // Вывод массива char
  myUART.print("Строка          : "); myUART.println("String 2, Строка 2");                   // Непосредственно строка
  myUART.print("Один символ     : "); myUART.println(Sim);                                    // Вывод 1го символа
  myUART.print("Переменная      : "); myUART.println(Alpha);                                  // Вывод переменной
  myUART.print("Число 100       : "); myUART.println(100);                                    // Вывод десятичного числа
  myUART.print("100 в HEX       : "); myUART.println(100, HEX);                               // Оно же в 16 ричном формате
  myUART.print("100 восмеричное : "); myUART.println(100, OCT);                               // В восмеричном
  myUART.print("100 бинарное    : "); myUART.println(100, BIN);                               // Бинарное представление
  myUART.print("Массив uint8_t  : "); myUART.write(Array, sizeof(Array));                     // Вывод массива
  myUART.print("\r\n\r\n");

  // Далее мы ждём принятие байта и выплёвываем его обратно
  while (1)
  {
    if((Get = myUART.read()) != -1) myUART.print((char) Get);
  }
}

void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
//  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

